; Ŀ
;      C U R V E D A T  1.0     
;       Copyright (c) 1991      
;       by Kurtis J. Jones      
; ٱ
;  
;
;
; This simple LISP program will allow you to select an arc entity, such as
; The center line of a highway curve, and display a "standard" highway
; curve data table for the curve on your AutoCAD drawing.  In order for the
; program to function properly, you must have the drawing block file
; "CURVEDAT.DWG" located in a subdirectory named "C:\ACAD\D", or else make
; the necessary changes to this LISP file in the block insertion line.
;
; CURVEDAT will only work on 2-D arc entities, and will not work on
; poloylines.
;
; If you have any questions are comments about CURVEDAT, I can be reached
; via THE SPECTRUM BBS, (501) 521-5639.
;

(defun C:CURVEDAT ()
   (prompt "\nSelect curve...")
   (setq CURVE (entget (car (entsel))))
   (setq R (cdr (assoc 40 CURVE)))
   (setq DELTA (- (cdr (assoc 51 CURVE))(cdr (assoc 50 CURVE))))
   (setq PIE 3.141592654)
   (setq L (* DELTA  R))
   (setq D (/ 100 R))
   (setq T (* R (/ (sin (/ DELTA 2))(cos (/ DELTA 2)))))
   (setq E (* T (/ (sin (/ DELTA 4))(cos (/ DELTA 4)))))
   (prompt "\nEnter Curve Number:")
   (setq cno (getstring))
   (prompt "\nEnter PI Station:")
   (setq PI (getreal))
   (setq PC (- PI T))
   (setq PT (+ PC L))
   (setq PT (STAPLUS PT))
   (setq PC (STAPLUS PC))
   (setq PI (STAPLUS PI))
   (setq E (rtos E 2 4))
   (setq T (rtos T 2 4))
   (setq L (rtos L 2 4))
   (setq R (rtos R 2 4))
   (setq D (angtos D 1 4))
   (setq DELTA (angtos DELTA 1 4))
   (setq LTS (getvar "LTSCALE"))

; * You may want to change the path in the following "insert" command *

   (command "insert" "c:/acad/d/curvedat" pause LTS "" "" CNO PT PC PI E T L R D DELTA)
   (princ)
)
(defun STAPLUS (STA)
   (setq STA1 (rtos (fix (/ STA 100))2 0))
   (setq LSTA1 (+ (strlen STA1)(if (=  STA1 "0") 0 1)))
   (setq STA2 (substr (rtos STA 2 2) LSTA1))
   (setq STA (strcat STA1 "+" STA2))
)